###############################################################################
#
# <p>Google GO</p>
# <pre>
#   {{gosetsuden tokyo 300,300}}
# </pre>
#
###############################################################################
package plugin::gosetsuden::Gosetsuden;
use LWP::UserAgent;
use XML::Simple;
use Unicode::RecursiveDowngrade;
use Data::Dumper;
#==============================================================================
# 󥹥ȥ饯
#==============================================================================
sub new {
  my $class = shift;
  my $self = {};
  $self->{count} = 1;
  return bless $self,$class;
}
#==============================================================================
# ѥ饰ե᥽å
#==============================================================================
sub paragraph {
  my $self = shift;
  my $wiki = shift;
  my $region = shift;
  my $gx = shift;
  my $gy = shift;
  my $on_off = shift;


  unless($region){
    $region = 'tokyo';
  }

  if($gx > 1000){
    $gx = 1000;
  }
  if($gy > 1000){
    $gy = 1000;
  }

  if($gx eq ''){
    $gx = 150;
  }
  if($gy eq ''){
    $gy = 150;
  }
  if($gx*$gy > 300000){
    $gx = 150;
    $gy = 150;
  }

#ԡ϶
  my $request_url = 'http://api.gosetsuden.jp/peak/'.$region.'/supply/today?output=xml';
  my $xml = get_response($request_url);
  my $peak_supply = $xml->{peak_supply}{supply}{content};

  unless($peak_supply){
    $peak_supply = 10000000;
  }

  my $out = "<small><br>綡̡".int($peak_supply / 10000)."kW";

#ͽۺϾ
  $request_url = 'http://api.gosetsuden.jp/peak/'.$region.'/demand/today?output=xml';
  $xml = get_response($request_url);
  my $peak_demand = $xml->{peak_demand}{demand}{content};

  $out .= "<br>ͽۥԡ".int($peak_demand / 10000)."kW";

  $peak_demand = $peak_demand / $peak_supply * 100;

  $out .= "(".int($peak_demand)."%)</small><br>";

#5ʬȤ˷¬줿Ͼ
  $request_url = 'http://api.gosetsuden.jp/usage/'.$region.'/instant/today';
  $request_url .= '?output=xml';
  $xml = get_response($request_url,1);

#return Dumper $xml;

  my $graph = '<img src=http://chart.apis.google.com/chart?';
  $graph .= 'chs='.$gx.'x'.$gy;
  $graph .= '&chd=t:100,100|'.$peak_demand.','.$peak_demand.'|';
  my $j = 0;
  my $k = '';
  foreach my $i (@{$xml->{instant_usage}->[0]{usage}}){
    if ($j++ > 0){
      $k = ',';
    }
    $k .= int($i->{content} / $peak_supply * 1000) / 10;
    if($region ne 'kansai'){
      $graph .= $k;
    }elsif ($j % 2) {
      $graph .= $k;
    }
  }

  if($region eq 'kansai'){
    $j = int($j / 2);
    $j = 10 * 24 - $j;
    $k = 20;
  }else{
    $j = 12 * 24 - $j;
    $k = 12;
  }

  foreach my $i (0..$j){
    if (($i == 0) && ($j == $k * 24)) {
      $graph .= "0";
    }
    $graph .= ",0";
  }
  $graph .= '|0,0';
  $graph .= '&cht=lc';
  $graph .= '&chxt=x,y';
  $graph .= '&chxl=0:|0|4|8|12|16|20|24|1:|0|20|40|60|80|100';
  $graph .= '&chco=ffffff,0000ff,6050ff,ffffff';
  $graph .= '&chm=b,c0b0ff,0,1,0|b,c0b0ff,1,2,0|b,6050ff,2,3,0>';

  if($on_off eq "off"){
    $out = "<br>";
  }

  return $graph.$out;

}

sub get_response {
  my $request_url = shift;
  my $force_array = shift;

  my $xml;
  my $UserAgent = 'Gosetsuden/0.1';

  my $ua = LWP::UserAgent->new;
  $ua->agent($UserAgent);
  my $res = $ua->get($request_url);
  if($res->is_success){
    my $rd = Unicode::RecursiveDowngrade->new;
    $xml = $rd->downgrade(XMLin($res->content,ForceArray => $force_array));
  }

  return $xml;
}
1;
